// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

/*
 * ETSI14REST
 *
 * OpenAPI definition of ETSI GS QKD 014 Standard.
 *
 * API version: 0.0.1
 */

package etsi14

import (
	"encoding/json"
	"net/http"
	"strings"
    "errors"
    "io"

	"github.com/gorilla/mux"
)

// DefaultAPIController binds http requests to an api service and writes the service results to the http response
type DefaultAPIController struct {
	service DefaultAPIServicer
	errorHandler ErrorHandler
}

// DefaultAPIOption for how the controller is set up.
type DefaultAPIOption func(*DefaultAPIController)

// WithDefaultAPIErrorHandler inject ErrorHandler into controller
func WithDefaultAPIErrorHandler(h ErrorHandler) DefaultAPIOption {
	return func(c *DefaultAPIController) {
		c.errorHandler = h
	}
}

// NewDefaultAPIController creates a default api controller
func NewDefaultAPIController(s DefaultAPIServicer, opts ...DefaultAPIOption) Router {
	controller := &DefaultAPIController{
		service:      s,
		errorHandler: DefaultErrorHandler,
	}

	for _, opt := range opts {
		opt(controller)
	}

	return controller
}

// Routes returns all the api routes for the DefaultAPIController
func (c *DefaultAPIController) Routes() Routes {
	return Routes{
		"GetKey": Route{
			strings.ToUpper("Get"),
			"/api/v1/keys/{slave_SAE_ID}/enc_keys",
			c.GetKey,
		},
		"GetKeyPost": Route{
			strings.ToUpper("Post"),
			"/api/v1/keys/{slave_SAE_ID}/enc_keys",
			c.GetKeyPost,
		},
		"GetKeyWithIds": Route{
			strings.ToUpper("Get"),
			"/api/v1/keys/{master_SAE_ID}/dec_keys",
			c.GetKeyWithIds,
		},
		"GetKeyWithIdsPost": Route{
			strings.ToUpper("Post"),
			"/api/v1/keys/{master_SAE_ID}/dec_keys",
			c.GetKeyWithIdsPost,
		},
		"GetStatus": Route{
			strings.ToUpper("Get"),
			"/api/v1/keys/{slave_SAE_ID}/status",
			c.GetStatus,
		},
	}
}

// GetKey - TBD
func (c *DefaultAPIController) GetKey(w http.ResponseWriter, r *http.Request) {
	params := mux.Vars(r)
	query, err := parseQuery(r.URL.RawQuery)
	if err != nil {
		c.errorHandler(w, r, &ParsingError{Err: err}, nil)
		return
	}
	slaveSAEIDParam := params["slave_SAE_ID"]
	if slaveSAEIDParam == "" {
		c.errorHandler(w, r, &RequiredError{"slave_SAE_ID"}, nil)
		return
	}
	var numberParam int64
	if query.Has("number") {
		param, err := parseNumericParameter[int64](
			query.Get("number"),
			WithParse[int64](parseInt64),
		)
		if err != nil {
			c.errorHandler(w, r, &ParsingError{Err: err}, nil)
			return
		}

		numberParam = param
	} else {
	}
	var sizeParam int64
	if query.Has("size") {
		param, err := parseNumericParameter[int64](
			query.Get("size"),
			WithParse[int64](parseInt64),
		)
		if err != nil {
			c.errorHandler(w, r, &ParsingError{Err: err}, nil)
			return
		}

		sizeParam = param
	} else {
	}
	result, err := c.service.GetKey(r.Context(), slaveSAEIDParam, numberParam, sizeParam)
	// If an error occurred, encode the error with the status code
	if err != nil {
		c.errorHandler(w, r, err, &result)
		return
	}
	// If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
}

// GetKeyPost -
func (c *DefaultAPIController) GetKeyPost(w http.ResponseWriter, r *http.Request) {
	params := mux.Vars(r)
	slaveSAEIDParam := params["slave_SAE_ID"]
	if slaveSAEIDParam == "" {
		c.errorHandler(w, r, &RequiredError{"slave_SAE_ID"}, nil)
		return
	}
	keyRequestParam := KeyRequest{}
	d := json.NewDecoder(r.Body)
	d.DisallowUnknownFields()
	if err := d.Decode(&keyRequestParam); err != nil && !errors.Is(err, io.EOF) {
		c.errorHandler(w, r, &ParsingError{Err: err}, nil)
		return
	}
	if err := AssertKeyRequestRequired(keyRequestParam); err != nil {
		c.errorHandler(w, r, err, nil)
		return
	}
	if err := AssertKeyRequestConstraints(keyRequestParam); err != nil {
		c.errorHandler(w, r, err, nil)
		return
	}
	result, err := c.service.GetKeyPost(r.Context(), slaveSAEIDParam, keyRequestParam)
	// If an error occurred, encode the error with the status code
	if err != nil {
		c.errorHandler(w, r, err, &result)
		return
	}
	// If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
}

// GetKeyWithIds - TBD
func (c *DefaultAPIController) GetKeyWithIds(w http.ResponseWriter, r *http.Request) {
	params := mux.Vars(r)
	query, err := parseQuery(r.URL.RawQuery)
	if err != nil {
		c.errorHandler(w, r, &ParsingError{Err: err}, nil)
		return
	}
	masterSAEIDParam := params["master_SAE_ID"]
	if masterSAEIDParam == "" {
		c.errorHandler(w, r, &RequiredError{"master_SAE_ID"}, nil)
		return
	}
	var keyIDParam string
	if query.Has("key_ID") {
		param := query.Get("key_ID")

		keyIDParam = param
	} else {
	}
	result, err := c.service.GetKeyWithIds(r.Context(), masterSAEIDParam, keyIDParam)
	// If an error occurred, encode the error with the status code
	if err != nil {
		c.errorHandler(w, r, err, &result)
		return
	}
	// If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
}

// GetKeyWithIdsPost - TBD
func (c *DefaultAPIController) GetKeyWithIdsPost(w http.ResponseWriter, r *http.Request) {
	params := mux.Vars(r)
	masterSAEIDParam := params["master_SAE_ID"]
	if masterSAEIDParam == "" {
		c.errorHandler(w, r, &RequiredError{"master_SAE_ID"}, nil)
		return
	}
	keyIdsRequestParam := KeyIdsRequest{}
	d := json.NewDecoder(r.Body)
	d.DisallowUnknownFields()
	if err := d.Decode(&keyIdsRequestParam); err != nil && !errors.Is(err, io.EOF) {
		c.errorHandler(w, r, &ParsingError{Err: err}, nil)
		return
	}
	if err := AssertKeyIdsRequestRequired(keyIdsRequestParam); err != nil {
		c.errorHandler(w, r, err, nil)
		return
	}
	if err := AssertKeyIdsRequestConstraints(keyIdsRequestParam); err != nil {
		c.errorHandler(w, r, err, nil)
		return
	}
	result, err := c.service.GetKeyWithIdsPost(r.Context(), masterSAEIDParam, keyIdsRequestParam)
	// If an error occurred, encode the error with the status code
	if err != nil {
		c.errorHandler(w, r, err, &result)
		return
	}
	// If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
}

// GetStatus - TBD
func (c *DefaultAPIController) GetStatus(w http.ResponseWriter, r *http.Request) {
	params := mux.Vars(r)
	slaveSAEIDParam := params["slave_SAE_ID"]
	if slaveSAEIDParam == "" {
		c.errorHandler(w, r, &RequiredError{"slave_SAE_ID"}, nil)
		return
	}
	result, err := c.service.GetStatus(r.Context(), slaveSAEIDParam)
	// If an error occurred, encode the error with the status code
	if err != nil {
		c.errorHandler(w, r, err, &result)
		return
	}
	// If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
}
