package utils

import (
	"fmt"
	"os/exec"
	"strings"
)

type Update struct {
	Path  string
	Value string
	JSON  string
}

func RunGosdncScript(script string, controllerURL string) (string, error) {
	cmd := exec.Command(script, controllerURL)

	output, err := cmd.CombinedOutput()
	outputString := string(output)

	if strings.Contains(outputString, "error") || strings.Contains(outputString, "ERROR") || err != nil {
		err = fmt.Errorf("error in output: %s", outputString)
	}

	return outputString, err
}

// Supports only kms00 to kms09.
func RestartKMS(dockerComposeFilePath string, kmsNumber int) error {
	cmd := exec.Command("docker-compose", "-f", dockerComposeFilePath, "restart", fmt.Sprintf("kms0%d", kmsNumber))

	output, err := cmd.CombinedOutput()
	outputString := string(output)

	if strings.Contains(outputString, "error") || strings.Contains(outputString, "ERROR") || err != nil {
		err = fmt.Errorf("error in output: %s", outputString)
	}

	return err
}
