package replaynumbergenerator

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

const pathToReplayFile = "../../config/replay_data/tu_1_a.csv"
const seed = 12345

func TestReplayNumberGenerator_InitializeRandomGenerator(t *testing.T) {
	rng := NewReplayNumberGenerator(pathToReplayFile, seed)

	err := rng.InitializeRandomGenerator()
	assert.NoError(t, err)
}

func TestReplayNumberGenerator_GenerateRandomBytes(t *testing.T) {
	rng := NewReplayNumberGenerator(pathToReplayFile, seed)

	err := rng.InitializeRandomGenerator()
	assert.NoError(t, err)

	bytes, numBytes, err := rng.GenerateRandomBytes()
	assert.NoError(t, err)

	assert.Equal(t, 953, numBytes)
	assert.Equal(t, 953, len(bytes))
}

func TestReplayNumberGenerator_GenerateRandomBytesSeedPersistence(t *testing.T) {
	rng := NewReplayNumberGenerator(pathToReplayFile, seed)

	err := rng.InitializeRandomGenerator()
	assert.NoError(t, err)

	bytes1, numBytes1, err := rng.GenerateRandomBytes()
	assert.NoError(t, err)

	assert.Equal(t, 953, numBytes1)
	assert.Equal(t, 953, len(bytes1))

	err = rng.InitializeRandomGenerator()
	assert.NoError(t, err)

	bytes2, numBytes2, err := rng.GenerateRandomBytes()
	assert.NoError(t, err)

	assert.Equal(t, 953, numBytes2)
	assert.Equal(t, 953, len(bytes2))

	assert.Equal(t, bytes1, bytes2)
	assert.Equal(t, numBytes1, numBytes2)
}
